> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Patch space collaborators

> Update a space collaborator



## OpenAPI

````yaml /swagger.json patch /space/{spaceId}/collaborators
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /space/{spaceId}/collaborators:
    patch:
      tags:
        - space
      description: Update a space collaborator
      parameters:
        - schema:
            type: string
          required: true
          name: invitationId
          in: path
        - schema:
            type: string
          required: true
          name: spaceId
          in: path
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                principalId:
                  type: string
                principalType:
                  type: string
                  enum:
                    - user
                    - department
                role:
                  type: string
                  enum:
                    - owner
                    - creator
                    - editor
                    - commenter
                    - viewer
              required:
                - principalId
                - principalType
                - role
      responses:
        '200':
          description: Successful response.
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request PATCH \
              --url https://app.teable.ai/api/space/%7BspaceId%7D/collaborators \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"principalId":"string","principalType":"user","role":"owner"}'
        - lang: JavaScript
          source: >-
            const url =
            'https://app.teable.ai/api/space/%7BspaceId%7D/collaborators';

            const options = {
              method: 'PATCH',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"principalId":"string","principalType":"user","role":"owner"}'
            };


            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: >-
            const http = require('https');


            const options = {
              method: 'PATCH',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/space/%7BspaceId%7D/collaborators',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };


            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });


            req.write(JSON.stringify({principalId: 'string', principalType:
            'user', role: 'owner'}));

            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"principalId\":\"string\",\"principalType\":\"user\",\"role\":\"owner\"}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("PATCH", "/api/space/%7BspaceId%7D/collaborators",
            payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````